#ifndef NORMALIZER_H
#define NORMALIZER_H

#include "Utility.h"
//#include "Structs.h"
#include "fsm.h"
#include "FileReader.h"

struct NormRule {
	wstring pattern;
	wstring replace;
};

class Normalizer
{
	/*static*/ FSM fsm;
	/*static*/ vector <NormRule> nRules;
public:
	Normalizer();
	~Normalizer();
	bool LoadNormRules (string filename);
	wstring NormalizeString(wstring str);
	void Clear ();
private:
	void ReplaceMatches (wstring& text);
	bool ReadPatterns (const char* filename);
	bool IsDiac (wchar_t wch);
	wstring DiacriticHehDoChasmee(wstring str) ;
};

#endif
